package frc.robot.subsystems;


import java.util.function.DoubleSupplier;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import edu.wpi.first.wpilibj.DigitalInput;
import edu.wpi.first.wpilibj.motorcontrol.VictorSP;
import edu.wpi.first.wpilibj2.command.Command;
import frc.robot.constants.FlickerConstants;

public class Flicker extends SubsystemBase {
    private VictorSP motor;

    private DigitalInput frisbySensor;

    public Flicker() {
        //sets motors and the photo switch
        motor = new VictorSP(FlickerConstants.k3motorPWM);

        frisbySensor = new DigitalInput(FlickerConstants.kPhotoSwitch);
    
    } 

    public boolean frisbySensor() {
        //makes the photoswitch useable for the if statment so the code will know if the photoswitch was blocked.
        return frisbySensor.get();
    } 
    public Command setSpeed(DoubleSupplier speed){
        //makes it so the motor will run but if the photoswitch can't see the frisby it will stop.
        return run(() -> {
            if (frisbySensor.get()) {
                    motor.set(speed.getAsDouble());
                } else { 
                    motor.set(0);
            }
        }); 
    }

    public Command stop() {
        // stops the motor manually.
        return setSpeed(() -> 0);
    } 
}
